var FoxySpiderOverlay =
{
  onLoad: function()
  {
    document.getElementById("contentAreaContextMenu")
      .addEventListener("popupshowing", function(e) {  FoxySpiderOverlay.showContextMenu(e); },  false);
      
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
                 
    if (prefs.prefHasUserValue("toolbarinit") == false || prefs.getBoolPref("toolbarinit") == false)
    {
      try
      {
        var firefoxnav = document.getElementById("nav-bar");
        var curSet = firefoxnav.currentSet;
        if (curSet.indexOf("foxyspider-toolbar-button") == -1)
        {
          var set;
          // Place the button before the urlbar
          if (curSet.indexOf("urlbar-container") != -1)
            set = curSet.replace(/urlbar\-container/, "foxyspider-toolbar-button,urlbar-container");
          else  // at the end
            set = curSet + ",foxyspider-toolbar-button";
          firefoxnav.setAttribute("currentset", set);
          firefoxnav.currentSet = set;
          document.persist("nav-bar", "currentset");
          // If you don't do the following call, funny things happen
          try
          {
            BrowserToolboxCustomizeDone(true);
          }
          catch (e) { }
        }
      }
      catch(e) { }

      prefs.setBoolPref("toolbarinit",true);
    }
  },
  onMenuItemCommand: function(e)
  {
    FoxySpiderMain.FoxySpiderMain();
  },
  onToolbarButtonClick : function(e)
  {
    if (e.button == 0)
    {
      FoxySpiderMain.FoxySpiderMain();
    }
    if (e.button == 1)
    {
      window.openDialog('chrome://foxyspider/content/advanced.xul');
    }
    if (e.button == 2)
    {
      window.openDialog('chrome://foxyspider/content/options.xul');
    }
    e.preventDefault();
  },
  showContextMenu: function(event)
  {
    var CurrUrl = FoxySpiderOverlay.GetCurrentUrl();
    document.getElementById("context-foxyspider").hidden = (CurrUrl == "chrome://foxyspider/content/gallery.html");
    document.getElementById("context-foxyspider-advanced").hidden = (CurrUrl == "chrome://foxyspider/content/gallery.html");
  },
  GetCurrentUrl : function()
  {
    return window.top.getBrowser().browsers[window.top.getBrowser().mTabBox.selectedIndex].contentDocument.URL;
  }
};

window.addEventListener("load",  function(e)  { FoxySpiderOverlay.onLoad(e);  }, false);
