var FoxySpiderAdvanced =
{
  CheckAccessibility : function()
  {
    document.getElementById("urlfilter-input").disabled = !document.getElementById("urlfilter-chk").checked;
    document.getElementById("filefilter-input").disabled = !document.getElementById("filefilter-chk").checked;
    document.getElementById("filefiltermode-menu").disabled = !document.getElementById("filefilter-chk").checked;
    document.getElementById("filefiltertype-menu").disabled = !document.getElementById("filefilter-chk").checked;
  },
  
  AdvancedOnLoad : function()
  {
    FoxySpiderAdvanced.CheckAccessibility();
        
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    
    var currUrl = win.top.getBrowser().browsers[win.top.getBrowser().mTabBox.selectedIndex].contentDocument.URL;
    document.getElementById("urlfilter-input").value = unescape(currUrl.match(/.*\//)) + "*";
  },
  
  StartFoxySpider : function()
  {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
                    
    if (document.getElementById("urlfilter-chk").checked)
      prefs.setCharPref("urlfilter",document.getElementById("urlfilter-input").value.toLowerCase());
      
    if (document.getElementById("filefilter-chk").checked)
    {
      prefs.setIntPref("filefiltermode",document.getElementById("filefiltermode-menu").value);
      prefs.setIntPref("filefiltertype",document.getElementById("filefiltertype-menu").value);
      prefs.setCharPref("filefilter",document.getElementById("filefilter-input").value.toLowerCase());
    }
                    
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    
    win.document.getElementById("context-foxyspider").click();
  }
}
