var FoxySpiderMain =
{
  FoxySpiderMain : function()
  {
    var doc = FoxySpiderMain.GetCurrentDocument();
    
    if (doc.URL == "chrome://foxyspider/content/gallery.html")
    {
      return;
    }

    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");

    FoxySpiderMain.GalleryTarget = prefs.getIntPref("gallerytarget");
    //prefs.setCharPref("lastcrawlurl",doc.URL);
    prefs.setCharPref("lastcrawlurl",gBrowser.currentURI.spec);
    
    if (FoxySpiderMain.GalleryTarget == 1) // new win
    {
      var brLnkPrefs = Components.classes["@mozilla.org/preferences-service;1"]
              .getService(Components.interfaces.nsIPrefService).getBranch("browser.link.");
      var currOpenNewWin = brLnkPrefs.getIntPref("open_newwindow");
      var currOpenNewWinRest = brLnkPrefs.getIntPref("open_newwindow.restriction");
      
      brLnkPrefs.setIntPref("open_newwindow",2);
      brLnkPrefs.setIntPref("open_newwindow.restriction",0);
      window.open("chrome://foxyspider/content/gallery.html","FoxySpider","scrollbars=yes,resizable=yes");
      brLnkPrefs.setIntPref("open_newwindow",currOpenNewWin);
      brLnkPrefs.setIntPref("open_newwindow.restriction",currOpenNewWinRest);
    }
    else if (FoxySpiderMain.GalleryTarget == 2) // new tab
    {
      var newTab = gBrowser.addTab("chrome://foxyspider/content/gallery.html");
      gBrowser.selectedTab = newTab;
    }
    else                                             // new tab (as a link)
    {
      var brLnkPrefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService).getBranch("browser.link.");
      var currOpenNewWin = brLnkPrefs.getIntPref("open_newwindow");
      var currOpenNewWinRest = brLnkPrefs.getIntPref("open_newwindow.restriction");
      var hook;
      
      if (doc.getElementsByTagName("BODY").length > 0)
        hook = doc.getElementsByTagName("BODY")[0];
      else if (doc.getElementsByTagName("HEAD").length > 0)
        hook = doc.getElementsByTagName("HEAD")[0];
      else if (doc.getElementsByTagName("HTML").length > 0)
        hook = doc.getElementsByTagName("HTML")[0];
      else
        hook = doc.body;
		
      var dummyButton = doc.createElement("button");
      dummyButton.setAttribute("id","fs_dummybotton");
      dummyButton.setAttribute("type","button");
      dummyButton.setAttribute("style","visibility: hidden; display: none;");
      dummyButton.setAttribute("onclick","window.open();");
        
      hook.appendChild(dummyButton);
      
      brLnkPrefs.setIntPref("open_newwindow",3);
      brLnkPrefs.setIntPref("open_newwindow.restriction",0);
      doc.getElementById("fs_dummybotton").click();
      brLnkPrefs.setIntPref("open_newwindow",currOpenNewWin);
      brLnkPrefs.setIntPref("open_newwindow.restriction",currOpenNewWinRest);
      
      gBrowser.loadURI("chrome://foxyspider/content/gallery.html");
    }
  },
  
  GetCurrentDocument : function()
  {
    return window.top.getBrowser().browsers[window.top.getBrowser().mTabBox.selectedIndex].contentDocument;
  }
};