var FoxySpiderOptions =
{
  CheckAccessibility : function()
  {
    document.getElementById("width-input").disabled = (document.getElementById("radio-resize").value!="resize");
    document.getElementById("resize-x-label").disabled = (document.getElementById("radio-resize").value!="resize");
    document.getElementById("height-input").disabled = (document.getElementById("radio-resize").value!="resize");
    
    document.getElementById("resizewidth-input").disabled = (document.getElementById("radio-resize").value!="resizewidth");
    
    document.getElementById("resizeheight-input").disabled = (document.getElementById("radio-resize").value!="resizeheight");
    
    document.getElementById("vidext-label").disabled = !document.getElementById("chk-video").checked;
    document.getElementById("vidext-input").disabled = !document.getElementById("chk-video").checked;
    document.getElementById("vidtarget-label").disabled = !document.getElementById("chk-video").checked;
    document.getElementById("vidtarget").disabled = !document.getElementById("chk-video").checked;
    
    document.getElementById("audext-label").disabled = !document.getElementById("chk-audio").checked;
    document.getElementById("audext-input").disabled = !document.getElementById("chk-audio").checked;
    document.getElementById("audtarget-label").disabled = !document.getElementById("chk-audio").checked;
    document.getElementById("audtarget").disabled = !document.getElementById("chk-audio").checked;
    
    document.getElementById("imgext-label").disabled = !document.getElementById("chk-image").checked;
    document.getElementById("imgext-input").disabled = !document.getElementById("chk-image").checked;
    document.getElementById("imgtarget-label").disabled = !document.getElementById("chk-image").checked;
    document.getElementById("imgtarget").disabled = !document.getElementById("chk-image").checked;
    
    document.getElementById("docext-label").disabled = !document.getElementById("chk-document").checked;
    document.getElementById("docext-input").disabled = !document.getElementById("chk-document").checked;
    document.getElementById("doctarget-label").disabled = !document.getElementById("chk-document").checked;
    document.getElementById("doctarget").disabled = !document.getElementById("chk-document").checked;
    
    document.getElementById("othext-label").disabled = !document.getElementById("chk-other").checked;
    document.getElementById("othext-input").disabled = !document.getElementById("chk-other").checked;
    document.getElementById("othtarget-label").disabled = !document.getElementById("chk-other").checked;
    document.getElementById("othtarget").disabled = !document.getElementById("chk-other").checked;
    
    
    document.getElementById("bjwidth-input").disabled = !document.getElementById("chk-bigjpg").checked;
    document.getElementById("bj-x-label").disabled = !document.getElementById("chk-bigjpg").checked;
    document.getElementById("bjheight-input").disabled = !document.getElementById("chk-bigjpg").checked;
    document.getElementById("bjtarget-label").disabled = !document.getElementById("chk-bigjpg").checked;
    document.getElementById("bjtarget").disabled = !document.getElementById("chk-bigjpg").checked;
    
    document.getElementById("numofimages-input").disabled = !document.getElementById("chk-limitgalleryto").checked;
    document.getElementById("numofpages-input").disabled = !document.getElementById("chk-limitcrawlpagesto").checked;
    document.getElementById("crawltime-input").disabled = !document.getElementById("chk-limitcrawltimeto").checked;
  },
  
  OpenUrl : function(URL)
  {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    var browser = win.getBrowser();
    var newTab = browser.addTab(URL);
    browser.selectedTab = newTab;
  },
  
  SendEmail : function()
  {
    document.getElementById("emailframe").setAttribute("src","");
    document.getElementById("emailframe").setAttribute("src","mailto:foxyspider@gmail.com");
  },
  
  OptionsOnLoad : function()
  {
    document.getElementById("facebookframe").setAttribute("src","http://www.facebook.com/plugins/likebox.php?id=128114783895156&width=240&connections=10&stream=false&header=false&height=255");
    FoxySpiderOptions.CheckAccessibility();
    FoxySpiderOptions.UpdateRgbAndHslFromColor();
    FoxySpiderOptions.initFilters();
  },
  
  OptionsOnAccept : function()
  {
    var list = [];
    var filterList = document.getElementById('filterList');
    var count = filterList.view.rowCount;
  
    for (var i=0; i<count; i++)
    {
      var rule = filterList.view.getCellText(i, filterList.columns['columnFilter']);
      var enabled = filterList.view.getCellValue(i, filterList.columns['columnEnable']);
      var item = rule + (enabled=="true" ? "" : "\b");
      list.push(item);
    }
    list.sort();

    var lightness = parseInt(document.getElementById("lightness-scale").value);
    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
             
    if (lightness < 30)
      prefs.setCharPref("textcolor","white");
    else
      prefs.setCharPref("textcolor","black");

    prefs.setCharPref("filterlist",list.join(" "));
  },
  
  ResetToDefault: function()
  {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
    var prefCount = {value:0}; 
    var prefArray = prefs.getChildList("" , prefCount);

    for (var i = 0; i < prefArray.length; ++i)
    {
      if (prefs.getPrefType(prefArray[i]) == prefs.PREF_INT)
      {
        prefs.setIntPref(prefArray[i],1);
        prefs.setIntPref(prefArray[i],0);
      }
      if (prefs.getPrefType(prefArray[i]) == prefs.PREF_STRING)
      {
        prefs.setCharPref(prefArray[i],"#FFFFFF");
        prefs.setCharPref(prefArray[i],"#000000");
      }
      if (prefs.getPrefType(prefArray[i]) == prefs.PREF_BOOL)
      {
        prefs.setBoolPref(prefArray[i],true);
        prefs.setBoolPref(prefArray[i],false);
      }
      try
      {
        prefs.clearUserPref(prefArray[i]);
      }
      catch(err)
      {
      }
    }
    FoxySpiderOptions.UpdateRgbFromColor();
    FoxySpiderOptions.UpdateHslFromColor();
    FoxySpiderOptions.initFilters();
  },
  
  UpdateRgbFromColor : function()
  {
    document.getElementById("bgcolor-text").value = document.getElementById("bgcolor").value;
    
    var redhex = document.getElementById("bgcolor").value.slice(1,3);
    var greenhex = document.getElementById("bgcolor").value.slice(3,5);
    var bluehex = document.getElementById("bgcolor").value.slice(5,7);
    
    var red = parseInt(redhex,16);
    var green = parseInt(greenhex,16);
    var blue = parseInt(bluehex,16);
    
    var callback = document.getElementById("red-scale").onchange;
    document.getElementById("red-scale").onchange = null;
    document.getElementById("green-scale").onchange = null;
    document.getElementById("blue-scale").onchange = null;
    document.getElementById("red-scale").value = red.toString();
    document.getElementById("green-scale").value = green.toString();
    document.getElementById("blue-scale").value = blue.toString();
    document.getElementById("red-scale").onchange = callback;
    document.getElementById("green-scale").onchange = callback;
    document.getElementById("blue-scale").onchange = callback;
  },
  
  UpdateHslFromColor : function()
  {
    document.getElementById("bgcolor-text").value = document.getElementById("bgcolor").value;
    
    var redhex = document.getElementById("bgcolor").value.slice(1,3);
    var greenhex = document.getElementById("bgcolor").value.slice(3,5);
    var bluehex = document.getElementById("bgcolor").value.slice(5,7);
    
    var red = parseInt(redhex,16);
    var green = parseInt(greenhex,16);
    var blue = parseInt(bluehex,16);
    
    function rgbToHsl(r, g, b){
      r /= 255, g /= 255, b /= 255;
      var max = Math.max(r, g, b), min = Math.min(r, g, b);
      var h, s, l = (max + min) / 2;
  
      if(max == min){
          h = s = 0; // achromatic
      }else{
          var d = max - min;
          s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
          switch(max){
              case r: h = (g - b) / d + (g < b ? 6 : 0); break;
              case g: h = (b - r) / d + 2; break;
              case b: h = (r - g) / d + 4; break;
          }
          h /= 6;
      }
  
      return [h, s, l];
    }
    
    var HSL = rgbToHsl(red,green,blue);
    
    var hue = Math.round(HSL[0]*360);
    var saturation = Math.round(HSL[1]*100);
    var lightness = Math.round(HSL[2]*100);
    
    var callback = document.getElementById("hue-scale").onchange;
    document.getElementById("hue-scale").onchange = null;
    document.getElementById("saturation-scale").onchange = null;
    document.getElementById("lightness-scale").onchange = null;
    document.getElementById("hue-scale").value = hue.toString();
    document.getElementById("saturation-scale").value = saturation.toString();
    document.getElementById("lightness-scale").value = lightness.toString();
    document.getElementById("hue-scale").onchange = callback;
    document.getElementById("saturation-scale").onchange = callback;
    document.getElementById("lightness-scale").onchange = callback;
  },
  
  UpdateRgbAndHslFromColor : function()
  {
    FoxySpiderOptions.UpdateRgbFromColor();
    FoxySpiderOptions.UpdateHslFromColor();
  },
  
  UpdateColor : function(red, green, blue)
  {
    function valToHex(val)
    {
      var retval = parseInt(val).toString(16).toUpperCase();
      if (retval.length<2)
        return "0"+retval;
      else
        return retval;
    }
    document.getElementById("bgcolor").value = "#" + valToHex(red) + valToHex(green) + valToHex(blue);
  },
  
  UpdateColorFromRGB : function()
  {
    FoxySpiderOptions.UpdateColor(parseInt(document.getElementById("red-scale").value),
                                  parseInt(document.getElementById("green-scale").value),
                                  parseInt(document.getElementById("blue-scale").value));
//    FoxySpiderOptions.UpdateHslFromColor();
  },
  
  UpdateColorFromHSL : function()
  {
    var hue = parseInt(document.getElementById("hue-scale").value);
    var saturation = parseInt(document.getElementById("saturation-scale").value);
    var lightness = parseInt(document.getElementById("lightness-scale").value);
    
    function hue2rgb(p, q, t)
    {
      if(t < 0) t += 1;
      if(t > 1) t -= 1;
      if(t < 1/6) return p + (q - p) * 6 * t;
      if(t < 1/2) return q;
      if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
      return p;
    }
          
    function hslToRgb(h, s, l)
    {
      var r, g, b;
  
      if(s == 0)
      {
        r = g = b = l; // achromatic
      }
      else
      {
        var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        var p = 2 * l - q;
        r = hue2rgb(p, q, h + 1/3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1/3);
      }
  
      return [r * 255, g * 255, b * 255];
    }
    
    var RGB = hslToRgb(parseInt(hue)/360,parseInt(saturation)/100,parseInt(lightness)/100);
    
    FoxySpiderOptions.UpdateColor(Math.round(RGB[0]),Math.round(RGB[1]),Math.round(RGB[2]));
//    FoxySpiderOptions.UpdateRgbFromColor();
  },
  
  initFilters : function()
  {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
                  
    var s = prefs.getCharPref("filterlist");
    
    var list = (s ? s.split(" ") : "");
    var rules = document.getElementById('filterChilds');
    while (rules.hasChildNodes()) rules.removeChild(rules.firstChild);
    for (var i = 0; i < list.length; i++)
    {
      if (list[i] != "")
      {
        var item = list[i].split("\b");
        var rule = item[0];
        var enabled = (item.length == 1);
        FoxySpiderOptions.addFilterRule(rule, enabled);
      }
    }
  },
   
   addFilterRule : function(rule, enabled)
   {
     var rules = document.getElementById('filterChilds');
     var item = document.createElement('treeitem');
     var row = document.createElement('treerow');
     var c1 = document.createElement('treecell');
     var c2 = document.createElement('treecell');
     c1.setAttribute('label', rule);
     c2.setAttribute('value', enabled);
     row.appendChild(c1);
     row.appendChild(c2);
     item.appendChild(row);
     rules.appendChild(item);
     return (rules.childNodes.length-1);
   },
   
   findRule : function(value)
   {
     var filterList = document.getElementById('filterList');
     var count = filterList.view.rowCount;
     for (var i=0; i<count; i++)
     {
        var rule = filterList.view.getCellText(i, filterList.columns['columnFilter']);
        if (rule == value)
          return i;
     }
     return -1;
  },
  
  updateAddButtonStatus : function()
  {
   var addbtn = document.getElementById('addbtn');
   var newfilter = document.getElementById('newfilter');
   addbtn.disabled = (newfilter.value.replace(/^\s*|\s*$/g,"").length < 1);
  },
  
  updateDelButtonStatus : function() 
  {
     var delbtn = document.getElementById('delbtn');
     var filterList = document.getElementById('filterList');
     delbtn.disabled = (filterList.view.selection.count < 1);
  },
   
   addNewFilter : function()
   {
     var filterList = document.getElementById('filterList');
     var newfilter = document.getElementById('newfilter');
     var rule = newfilter.value.replace(/^\s*|\s*$/g,"");
     if (rule != "")
     {
        rule = rule.replace(/\s/g, "%20");
        var idx = FoxySpiderOptions.findRule(rule);
        if (idx == -1)
        {
          idx = FoxySpiderOptions.addFilterRule(rule, true);
          newfilter.value = "";
        }
        filterList.view.selection.select(idx);
        filterList.boxObject.ensureRowIsVisible(idx);
     }
     filterList.focus();
     FoxySpiderOptions.updateAddButtonStatus();
  },
  
  delFilter : function()
  {
     var filterList = document.getElementById('filterList');
     var rules = document.getElementById('filterChilds');
     
     if (filterList.view.selection.count > 0)
     {
        for (var i=rules.childNodes.length-1 ; i>=0 ; i--) {
           if (filterList.view.selection.isSelected(i))
              rules.removeChild(rules.childNodes[i]);
        }
     }
     FoxySpiderOptions.updateDelButtonStatus();
  },
  
  onClickFilterList : function(e) 
  {
     var filterList = document.getElementById('filterList');
     if (e.button == 0 && e.detail >= 2)
     {
        if (filterList.view.selection.count == 1)
        {
           var newfilter = document.getElementById('newfilter');
           newfilter.value = filterList.view.getCellText(filterList.currentIndex, filterList.columns['columnFilter']);
           newfilter.select();
           FoxySpiderOptions.updateAddButtonStatus();
        }
     }
   }
}
